;X-Link 64 v1.0, server source.
;A transfer program for KM's 6502 Assembler
;(c) 1997-98 by Piotr Tracz aka kmeG/Albion & Shape
;All Rights Reserved
;e-mail: piotr@shape.tm or ptracz@ajax.umcs.lublin.pl
;kmeg@mercator.umcs.lublin.pl, kmeg@gnom.iung.pulawy.pl 
;ftp://ftp.elysium.pl
;working on all LPT ports!!! (I do hope so ;)  
;Rev.C

; The file structure (offsets):

; $00-$01 - C64 memory load adress
; $02-$03 - program entry point (if equal to 0 then just load)
; $04-$05 - lenght of file
; $06-$xx - the main file

; Program DOES NOT send two first bytes of C64 file (c64 file load-address)

; Program doesn't inicialize LPT port and if bios doesn't inicialize it correctly you must
; reboot your pc

; On very fast PCs you may got error "C64 is not responding" even if C64 is responding.
; It's caused by using loops and not timers in Time_Out routine (it's very easy to fix up!)
; It may be real problem for people having K7 based system... or not ;)
; However the transmision itself is very stable (as it supposed to be)

; Multitasking operating systems are ignored. XLink64 will still work stable aganist them!

; No comments, sorry I'm out of time.

; Dirty code, out of optimization (if you didn't find it by yourself ;)


;                          PC64 CABLE:
;                          
;                       pc           c64

;                 0 d0   ------> pb4  4Ŀ
;                 1 d1   ------> pb5  5Ĵ $dd01
;          $xx7   2 d2   ------> pb6  6Ĵ
;                 3 d3   ------> pb7  7
;                 7 d7   ------> flag 4  $dd0d
;                       gnd  ------- gnd
;                 3 err  <------ pb0  0Ŀ
;                 4 sel  <------ pb1  1Ĵ $dd01
;          $xx9   5 pe   <------ pb2  2Ĵ
;                 6 ack  <------ pb3  3
;                 7 busy <------ pa2  2 $dd00
;          
; NOTICE:  flag is set on c64 only when line-state = 0 and is read-only!

.386
.MODEL TINY
DSTACK SEGMENT STACK 'STACK' use16
db 1000 dup (?)
DSTACK ENDS
ASSUME CS:CODE,DS:CODE
CODE SEGMENT use16
;-------------------------------------------------------------------
Start:

                   mov ax,es
                   mov cs:PSP,ax
                   mov ax, SEG CODE
                   mov ds,ax
                   mov cs:RDS,ax
                   mov ax,1
                   call print_com
                   call getparams
                   mov ax,cs:RDS
                   mov ds,ax
                   call load
                   call init_progress
                   call send_to_c64


exit:              mov ax,4c01h
                   int 21h
                   ret

;--------------------------------
send_to_c64:       sub bufor_size,2
                   mov ax, bufor_size
                   sar ax,3
                   and ax,0001111111111111b
                   mov trash, ax
                   mov cx,bufor_size
                   mov shit,0
                   mov ax, SEG DATAZ
                   push ds
                   mov ds, ax
                   mov bx, offset DATAZ:Bufor
                   mov al, [bx]
                   inc bx
                   mov ah, [bx]
                   inc bx
                   pop ds
                   push cx
                   call send_header
                   pop cx
send_next:         push cx
                   mov ax, SEG DATAZ
                   push ds
                   mov ds,ax
                   mov al, [bx]
                   pop ds
                   call send_byte
                   inc bx
                   inc shit
                   mov ax,trash
                   cmp shit, ax
                   jnz skip_hash
                   mov shit,0
                   mov dl,'#'
                   mov ah,02
                   int 21h
skip_hash:         pop cx
                   loop send_next
                   ret
send_header:       push cx
                   push ax
                   call send_byte  ;load mb
                   pop ax
                   sar ax,8
                   call send_byte  ;load sb
                   mov ax, start_adress
                   push ax
                   sar ax,8
                   call send_byte
                   pop ax
                   call send_byte
                   pop cx
                   mov ax, cx
                   push ax
                   call send_byte
                   pop ax
                   sar ax,8
                   call send_byte
                   ret
send_byte:         push ax
                   mov dx, CODE:port_adress
                   and al, 00001111b
                   or al,  10000000b
                   out dx, al
                   and al, 00001111b
                   out dx, al
                   inc dx
                   mov cx, 60000
wait_for_c64_1:    in al, dx
                   dec cx
                   jz time_out
                   and al, 00001000b
                   jz wait_for_c64_1
                   pop ax
                   sar al,4
                   or al, 10000000b
                   dec dx
                   out dx, al
                   and al, 00001111b
                   out dx, al
                   inc dx
                   mov cx, 60000
wait_for_c64_2:    in al, dx
                   dec cx
                   jz time_out
                   and al, 00001000b
                   jnz wait_for_c64_2
                   ret
time_out:          mov ax,10
                   call print_com
                   jmp exit

;=========================
getparams:         mov ax,PSP
                   mov ds,ax
                   mov si,80h         ; Start of parameters
                   cld                ; SI = current parameter pos
                   lodsb
                   movzx cx,al          ; CX = characters left+1
                   jcxz no_cmdline
                   inc cx
SkipSpace:         call get_param_byte
                   cmp al,' '
                   jne NoSpace
                   jmp SkipSpace
NoSpace:           cmp al,'-'         ; Check if its parameter or filename 
                   je  Parameter
                   mov ax,8
                   call print_com
                   jmp exit

cmd:               mov     di,offset FileName
ReadName:          push cs
                   pop es
ReadName_:         stosb
                   lodsb
                   loop ReadName_
                   mov al,0
                   stosb
                   jmp Done
Parameter:         call get_param_byte
                   cmp al,'p'
                   jne no_port
                   call get_port
                   call get_param_byte
                   call get_param_byte
                   cmp al, '-'
                   jne cmd
                   call get_param_byte
                   cmp al, 's'
                   jne cmd_error
                   call get_start
                   jmp cmd

get_param_byte:    lodsb
                   dec cx
                   jz Done
                   ret
no_port:           mov ax,8
                   call print_com
                   jmp exit
no_cmdline:        mov ax,2
                   call print_com
                   jmp exit
cmd_error:         mov ax,3
                   call print_com
                   jmp exit
Done:              cmp byte ptr cs:[Filename],0
                   je  cmd_error
                   ret
get_start:         call get_param_byte
                   call convert_to_hex
                   sal ax,12
                   add cs:start_adress, ax
                   call get_param_byte
                   call convert_to_hex
                   xor ah,ah
                   sal ax,8
                   add cs:start_adress, ax
                   call get_param_byte
                   call convert_to_hex
                   xor ah,ah
                   sal ax,4
                   add cs:start_adress, ax
                   call get_param_byte
                   call convert_to_hex
                   xor ah,ah
                   add cs:start_adress, ax
                   call get_param_byte
                   call get_param_byte
                   ret
convert_to_hex:    cmp al, '0'
                   jb bad_char
                   cmp al,'9'
                   jbe found_num
                   cmp al, 'a'
                   jb bad_char
                   cmp al,'f'
                   jg bad_char
                   sub al, 'a'
                   add al, 10
                   ret
found_num:         sub al, '0'
                   ret
bad_char:          mov ax,11
                   call print_com
                   jmp exit
get_port:          lodsb
                   cmp al,'2'
                   jne pr_1
                   mov cs:port_adress, 0278h
                   jmp pr_3
pr_1:              cmp al,'3'
                   je pr_2
bad_port:          mov ax,9
                   call print_com
                   jmp exit
pr_2:              mov cs:port_adress, 0378h
pr_3:              dec cx
                   jz bad_port
                   call get_param_byte
                   cmp al, '7'
                   jnz bad_port
                   call get_param_byte
                   cmp al, '8'
                   jnz bad_port
                   ret

;============
print_com:         push ax
                   mov ax,cs:RDS
                   mov ds,ax
                   pop ax
                   mov trash,0
                   mov shit,0
                   mov dx,offset com_table
p_com:             inc shit
                   inc trash
                   cmp shit,ax
                   jne next_com
                   add dx,trash
                   mov ah,09h
                   mov al,00h
                   int 21h
                   ret
next_com:          mov bx,dx
                   add bx,trash
                   cmp byte ptr [bx],'$'
                   je p_com
                   cmp byte ptr [bx],0ffh
                   je com_notfound
                   inc trash
                   jmp next_com
com_notfound:      ret
;===================
load:              mov ax,03d00h
                   lea dx,filename
                   int 21h
                   jb load_err1
                   mov fhandle,ax
                   call file_size
                   push ds

                   mov bx,fhandle
                   mov ax, SEG DATAZ
                   mov ds,ax
                   mov cx,0ff00h
                   mov dx,offset bufor
                   mov ah,03fh
                   int 21h
                   pop ds
filend:            mov bx,fhandle
                   mov ah,3eh
                   int 21h
                   ret
load_err1:         mov ax,4
                   call print_com
                   jmp exit
file_size:         mov bx,fhandle
                   mov ax,04202h
                   xor cx,cx
                   xor dx,dx
                   int 21h
                   mov fsize,ax
                   cmp dx,0
                   jne file_too_big
                   mov bufor_size,ax
                   cmp ax,0ffffh
                   jnb file_too_big
                   mov bx,fhandle
                   xor cx,cx
                   xor dx,dx
                   mov ax,04200h
                   int 21h
                   ret
file_too_big:      mov ax,5
                   call print_com
                   jmp exit
;==========================
init_progress:     mov ax,6
                   call print_com
                   mov ax,bufor_size
                   call print_val
                   mov ax,7
                   call print_com
                   ret
print_progress:    mov dl,'#'
                   mov ah,02
                   int 21h
                   ret
;===========================
print_val:         mov cx,0ffffh           ;ax - value
                   push cx
                   mov cx,10
pd1:               mov dx,0
                   div cx
                   add dl,30h
                   push dx
                   cmp ax,0
                   jne pd1
pd2:               pop dx
                   cmp dx,0ffffh
                   je  pd3
                   mov ah,02
                   int 21h
                   inc x_poz
                   jmp pd2
pd3:               ret


;--------------------------------
PSP             dw ?
RDS             dw ?
ScrBase         dw 0b800h
trash           dw 00h          ;very usable byte B-]
shit            dw 00h
shit_           db 00h
filename        db 0,('            ');8+3+(.)+(0)
fhandle         dw 00h
fsize           dw 00h
bsent           dw 00h
bufor_size      dw 00h
port_adress     dw 00h
start_adress    dw 00h
loadmb          db 00h
loadsb          db 00h
x_poz           db 00h
y_poz           db 00h
x_tmp           db 00h
y_tmp           db 00h
com_table       db 20h,0ah,0dh
                db ('X-Link64 v0.1b (c) 1997-98 ALBION/SHAPE PRODUCTION');1
                db 0dh,0ah,0ah,('$')
                db ('XLink64.exe -pxxx [-sxxxx] filename$') ;2
                db ('error: bad command line!$') ;3
                db ('error: file not found!$') ;4
                db ('error: file is too big!$') ;5
                db 0dh
                db ('bytes to send: $') ;6
                db 0dh,0ah,('progress: $') ;7
                db ('error: no port number given!$') ;8
                db ('error: bad port adress!$') ;9
                db 0dh,0ah,0ah
                db ('error: C64 is not responding!$') ;10
                db ('error: bad start adress!$') ;11
                db 0ffh
CODE ENDS
DATAZ SEGMENT use16
Bufor         